Skia图形库
=====================

Skia是一个开源的二维图形库，提供各种常用的API，并可在多种软硬件平台上运行。谷歌Chrome浏览器、Chrome
OS、安卓、火狐浏览器、火狐操作系统以及其它许多产品都使用它作为图形引擎。

<!-- Skia is an open source 2D graphics library which provides common APIs that work
across a variety of hardware and software platforms.  It serves as the graphics
engine for Google Chrome and Chrome OS, Android, Mozilla Firefox and Firefox
OS, and many other products.
 -->

Skia由谷歌出资管理，任何人都可基于BSD免费软件许可证使用Skia。Skia开发团队致力于开发其核心部分，
并广泛采纳各方对于Skia的开源贡献。

<!-- Skia is sponsored and managed by Google, but is available for use by anyone
under the BSD Free Software License.  While engineering of the core components
is done by the Skia development team, we consider contributions from any
source.
 -->

<!-- Canonical source tree: -->
  * 源代码:
    [skia.googlesource.com/skia](https://skia.googlesource.com/skia).
<!-- Issue tracker -->
  * 提议:
    [bug.skia.org](https://bug.skia.org/).
<!-- Discussion forum -->
  * 论坛:
    [skia-discuss@googlegroups.com](https://groups.google.com/forum/#!forum/skia-discuss).

<!-- Showcase -->
示例
--------

<!-- Click on any image below to see the source code that generated the image. -->
点击以下任意图像查看生成该图像的源代码。
<table>
  <tr><th><!-- Shapes -->几何形状</th><th><!-- Bézier Curves -->贝塞尔曲线</th></tr>
  <tr>
    <td>
      <a href='https://fiddle.skia.org/c/@shapes'>
        <img src='https://fiddle.skia.org/i/@shapes_raster.png'>
      </a>
    </td>
    <td>
      <a href='https://fiddle.skia.org/c/@bezier_curves'>
        <img src='https://fiddle.skia.org/i/@bezier_curves_raster.png'>
      </a>
    </td>
  </tr>

  <tr>
    <th><!-- Translations and Rotations -->平移与旋转</th>
    <th><!-- Text Rendering -->文字渲染</th>
  </tr>
  <tr>
    <td>
      <a href='https://fiddle.skia.org/c/@rotations'>
        <img src='https://fiddle.skia.org/i/@rotations_raster.png'>
      </a>
    </td>
    <td>
      <a href='https://fiddle.skia.org/c/@text_rendering'>
        <img src='https://fiddle.skia.org/i/@text_rendering_raster.png'>
      </a>
    </td>
  </tr>

  <tr>
    <th><!-- Discrete Path Effects -->离散路径特效</th>
    <th><!-- Composed Path Effects -->合成路径特效</th>
  </tr>
  <tr>
    <td>
      <a href='https://fiddle.skia.org/c/@discrete_path'>
        <img src='https://fiddle.skia.org/i/@discrete_path_raster.png'>
      </a>
    </td>
    <td>
      <a href='https://fiddle.skia.org/c/@compose_path'>
        <img src='https://fiddle.skia.org/i/@compose_path_raster.png'>
      </a>
    </td>
  </tr>
  <tr><th><!-- Sum Path Effects -->叠加路径特效</th><th><!-- Shaders -->着色器</th></tr>
  <tr>
    <td>
      <a href='https://fiddle.skia.org/c/@sum_path_effect'>
        <img src='https://fiddle.skia.org/i/@sum_path_effect_raster.png'>
      </a>
    </td>
    <td>
      <a href='https://fiddle.skia.org/c/@shader'>
        <img src='https://fiddle.skia.org/i/@shader_raster.png'>
      </a>
    </td>
  </tr>
</table>

<!-- Roadmap -->
发展规划
-------
<!-- For a look at high level items we have on tap the next 6-12 months, view our
roadmap [here]
(https://docs.google.com/document/d/1C9w8qpPpdgNGThqmgNnTToLZ5UYK4TsUGl5X3B_q6oM/edit?usp=sharing).
Note it is a living document that changes based on the requirements of our users. -->

如果想大概了解我们接下来6-12个月会触及的项目,请查看[该文档]
(https://docs.google.com/document/d/1C9w8qpPpdgNGThqmgNnTToLZ5UYK4TsUGl5X3B_q6oM/edit?usp=sharing)。
请注意,该文档会根据我们用户的需求实时更新。
